
uniform sampler2D envTexture;
uniform sampler2D blur1;
uniform sampler2D blur2;
uniform sampler2D blur3;
uniform sampler2D blur4;
uniform sampler2D blur5;
uniform sampler2D blur6;

uniform float w1;
uniform float w2;
uniform float w3;
uniform float w4;
uniform float w5;
uniform float w6;

uniform float exposure;
uniform float sizeX,sizeY;
vec3 mean;
vec3 color;

float k = 0.6;

// Lookup in RGBE-encoded texture
#define EXP_BASE 1.05
vec3 tex_RGBE(sampler2D tex, vec2 t,float level)
{
   vec4 rgbe = texture2D(tex, t,level);
   float e = (rgbe[3] * 255.0)-128.0;
   rgbe.rgb = rgbe.rgb * pow(EXP_BASE,e);
   return rgbe.rgb;
}

void main (void)
{
    
	
	
	color = tex_RGBE(envTexture, vec2(gl_TexCoord[0]),0);
	mean = tex_RGBE(envTexture, vec2(gl_TexCoord[0]),10);

	vec3 outcolor = vec3(0.0,0.0,0.0);

	outcolor += w1*(log(color)-k*log(tex_RGBE(blur1, vec2(gl_TexCoord[0]),0)));
	outcolor += w2*(log(color)-k*log(tex_RGBE(blur2, vec2(gl_TexCoord[0]),0)));
	outcolor += w3*(log(color)-k*log(tex_RGBE(blur3, vec2(gl_TexCoord[0]),0)));
	outcolor += w4*(log(color)-k*log(tex_RGBE(blur4, vec2(gl_TexCoord[0]),0)));
	outcolor += w5*(log(color)-k*log(tex_RGBE(blur5, vec2(gl_TexCoord[0]),0)));
	outcolor += w6*(log(color)-k*log(tex_RGBE(blur6, vec2(gl_TexCoord[0]),0)));
	
	gl_FragColor.rgb = exp(outcolor);
}	