
uniform sampler2D envTexture;
uniform float exposure;
uniform float sizeX,sizeY;

vec3 mean;
vec3 color;
// Lookup in RGBE-encoded texture
#define EXP_BASE 1.05
vec3 tex_RGBE(sampler2D tex, vec2 t,float level)
{
   vec4 rgbe = texture2D(tex, t,level);
   float e = (rgbe[3] * 255.0)-128.0;
   rgbe.rgb = rgbe.rgb * pow(EXP_BASE,e);
   return rgbe.rgb;
}

void main (void)
{
	color = tex_RGBE(envTexture, vec2(gl_TexCoord[0]),0);

	//Mean is the value in the lowest mipmaplevel, 1 pixel. It should be close to the mean of the texture
	mean = tex_RGBE(envTexture, vec2(gl_TexCoord[0]),10)*exposure;

	//Using the S-curve tonemapping 	
	color.r = color.r / (color.r + mean.r);
	color.g = color.g / (color.g + mean.g);
	color.b = color.b / (color.b + mean.b);

	
	gl_FragColor.rgb = color;
}	
